xref: /freebsd/libexec/rc/rc.subr (revision 49086aa35d987b78dbc3c9ec94814fe338e07164)
1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2#
3# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
4# All rights reserved.
5#
6# This code is derived from software contributed to The NetBSD Foundation
7# by Luke Mewburn.
8#
9# Redistribution and use in source and binary forms, with or without
10# modification, are permitted provided that the following conditions
11# are met:
12# 1. Redistributions of source code must retain the above copyright
13#    notice, this list of conditions and the following disclaimer.
14# 2. Redistributions in binary form must reproduce the above copyright
15#    notice, this list of conditions and the following disclaimer in the
16#    documentation and/or other materials provided with the distribution.
17#
18# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
19# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
20# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
21# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
22# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
23# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
24# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
25# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
26# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
27# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
28# POSSIBILITY OF SUCH DAMAGE.
29#
30# rc.subr
31#	functions used by various rc scripts
32#
33
34: ${RC_PID:=$$}; export RC_PID
35
36#
37#	Operating System dependent/independent variables
38#
39
40if [ -n "${_rc_subr_loaded}" ]; then
41	return
42fi
43
44_rc_subr_loaded="YES"
45
46SYSCTL="/sbin/sysctl"
47SYSCTL_N="${SYSCTL} -n"
48SYSCTL_W="${SYSCTL}"
49PROTECT="/usr/bin/protect"
50ID="/usr/bin/id"
51IDCMD="if [ -x $ID ]; then $ID -un; fi"
52PS="/bin/ps -ww"
53SERVICE=/usr/sbin/service
54JAIL_CMD=/usr/sbin/jail
55_svcj_generic_params="path=/ mount.nodevfs host=inherit"
56JID=0
57CPUSET="/bin/cpuset"
58
59# rc_service provides the path to the service script that we are executing.
60# This is not being set here in an execution context, necessarily, so it's
61# really just a reasonable guess, and it will get overwritten later if
62# we are executing from some other means than direct execution by service(8)
63# or manual invocation of the service script.  The prime example of this is
64# during system startup, all rc scripts will be invoked via /etc/rc, so
65# run_rc_script will overwrite rc_service with the file being sourced.
66rc_service="$0"
67
68#
69#	functions
70#	---------
71
72# is_verified file
73#	if VERIEXEC is active check that $file is verified
74#
75VERIEXEC="/sbin/veriexec"
76if test -x $VERIEXEC && $VERIEXEC -i active > /dev/null 2>&1; then
77	is_verified() { $VERIEXEC -x $1; }
78else
79	is_verified() { return 0; }
80fi
81
82# indicate that we have vdot
83_VDOT_SH=:
84
85# current state of O_VERIFY
86o_verify()
87{
88	case $(echo $(set -o)) in
89	*verify" "off*) echo off;;
90	*verify" "on*) echo on;;
91	esac
92}
93
94##
95# o_verify_set want [save]
96#
97# record current state of verify in $save
98# and set it to $want if different
99#
100o_verify_set() {
101	local x=$(o_verify)
102
103	[ -z "$x" ] && return 0
104	[ -z "$2" ] || eval $2=$x
105	[ "$x" = "$1" ] && return 0
106	case "$1" in
107	on)
108		set -o verify
109		;;
110	off)
111		set +o verify
112		;;
113	esac
114}
115
116# for unverified files
117dotted=
118dot()
119{
120	local f verify
121
122	o_verify_set off verify
123	for f in "$@"; do
124		if [ -f $f -a -s $f ]; then
125			dotted="$dotted $f"
126			. $f
127		fi
128	done
129	o_verify_set $verify
130}
131
132# try for verified, fallback to safe
133sdot()
134{
135	local f
136
137	for f in "$@"; do
138		[ -f $f -a -s $f ] || continue
139		vdot $f || safe_dot $f
140	done
141}
142
143# convenience function - skip if not verified
144vdot()
145{
146	local f rc=0 verify
147
148	o_verify_set on verify
149	for f in "$@"; do
150		[ -f $f -a -s $f ] || continue
151		if is_verified $f 2> /dev/null; then
152			dotted="$dotted $f"
153			. $f
154		else
155			rc=80	# EAUTH
156		fi
157	done
158	o_verify_set $verify
159	return $rc
160}
161
162# Exists [test] file ...
163# report the first "file" that passes "test" (default -s).
164Exists()
165{
166	local f _t=-s
167
168	while :; do
169		: 1=$1
170		case "$1" in
171		-?)
172			_t=$1
173			shift
174			;;
175		*)
176			break
177			;;
178		esac
179	done
180
181	for f in "$@"; do
182		[ $_t $f ] || continue
183		echo $f
184		return 0
185	done
186	return 1
187}
188
189# do we have $1 (could be a function)
190have()
191{
192       type "$1" > /dev/null 2>&1
193}
194
195# provide consistent means of logging progress
196rc_log()
197{
198	date "+@ %s [%Y-%m-%d %H:%M:%S %Z] $*"
199}
200
201# only rc_log if tracing enabled
202# and $level >= $RC_LEVEL
203rc_trace()
204{
205	local level=$1; shift
206	local cf=/etc/rc.conf.d/rc_trace
207
208	if [ -z "$RC_LEVEL" ]; then
209		[ -f $cf ] || return
210		if [ -s $cf ]; then
211			# don't try to set RC_LEVEL without sed
212			if [ -n "$SED" ]; then
213				RC_LEVEL=$($SED -n '/^RC_LEVEL=/ { s/.*=//p;q; }' $cf)
214				RC_LEVEL=${RC_LEVEL:-0}
215			fi
216		else
217			RC_LEVEL=0
218		fi
219	fi
220	[ ${RC_LEVEL:-0} -ge ${level:-0} ] || return
221	rc_log "$@"
222}
223
224# list_vars pattern
225#	List variables matching glob pattern.
226#
227list_vars()
228{
229	# Localize 'set' option below.
230	local -
231	local IFS=$'\n' line varname
232
233	# Disable path expansion in unquoted 'for' parameters below.
234	set -o noglob
235
236	for line in $(set); do
237		varname="${line%%=*}"
238
239		case "$varname" in
240		"$line"|*[!a-zA-Z0-9_]*)
241			continue
242			;;
243		$1)
244			echo $varname
245			;;
246		esac
247	done
248}
249
250# set_rcvar [var] [defval] [desc]
251#
252#	Echo or define a rc.conf(5) variable name.  Global variable
253#	$rcvars is used.
254#
255#	If no argument is specified, echo "${name}_enable".
256#
257#	If only a var is specified, echo "${var}_enable".
258#
259#	If var and defval are specified, the ${var} is defined as
260#	rc.conf(5) variable and the default value is ${defvar}.  An
261#	optional argument $desc can also be specified to add a
262#	description for that.
263#
264set_rcvar()
265{
266	local _var
267
268	case $# in
269	0)	echo ${name}_enable ;;
270	1)	echo ${1}_enable ;;
271	*)
272		debug "set_rcvar: \$$1=$2 is added" \
273		    " as a rc.conf(5) variable."
274		_var=$1
275		rcvars="${rcvars# } $_var"
276		eval ${_var}_defval=\"$2\"
277		shift 2
278		eval ${_var}_desc=\"$*\"
279	;;
280	esac
281}
282
283# set_rcvar_obsolete oldvar [newvar] [msg]
284#	Define obsolete variable.
285#	Global variable $rcvars_obsolete is used.
286#
287set_rcvar_obsolete()
288{
289	local _var
290	_var=$1
291	debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
292
293	rcvars_obsolete="${rcvars_obsolete# } $1"
294	eval ${1}_newvar=\"$2\"
295	shift 2
296	eval ${_var}_obsolete_msg=\"$*\"
297}
298
299#
300# force_depend script [rcvar]
301#	Force a service to start. Intended for use by services
302#	to resolve dependency issues.
303#	$1 - filename of script, in /etc/rc.d, to run
304#	$2 - name of the script's rcvar (minus the _enable)
305#
306force_depend()
307{
308	local _depend _dep_rcvar
309
310	_depend="$1"
311	_dep_rcvar="${2:-$1}_enable"
312
313	[ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
314	    checkyesno $_dep_rcvar && return 0
315
316	/etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
317
318	info "${name} depends on ${_depend}, which will be forced to start."
319	if ! /etc/rc.d/${_depend} forcestart; then
320		warn "Unable to force ${_depend}. It may already be running."
321		return 1
322	fi
323}
324
325#
326# checkyesno var
327#	Test $1 variable, and warn if not set to YES or NO.
328#	Return 0 if it's "yes" (et al), nonzero otherwise.
329#
330checkyesno()
331{
332	eval _value=\$${1}
333	debug "checkyesno: $1 is set to $_value."
334	case $_value in
335
336		#	"yes", "true", "on", or "1"
337	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
338		return 0
339		;;
340
341		#	"no", "false", "off", or "0"
342	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
343		return 1
344		;;
345	*)
346		warn "\$${1} is not set properly - see rc.conf(5)."
347		return 1
348		;;
349	esac
350}
351
352#
353# reverse_list list
354#	print the list in reverse order
355#
356reverse_list()
357{
358	_revlist=
359	for _revfile; do
360		_revlist="$_revfile $_revlist"
361	done
362	echo $_revlist
363}
364
365# stop_boot always
366#	If booting directly to multiuser or $always is enabled,
367#	send SIGTERM to the parent (/etc/rc) to abort the boot.
368#	Otherwise just exit.
369#
370stop_boot()
371{
372	local always
373
374	case $1 in
375		#	"yes", "true", "on", or "1"
376	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
377		always=true
378		;;
379	*)
380		always=false
381		;;
382	esac
383	if [ "$autoboot" = yes -o "$always" = true ]; then
384		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
385		kill -TERM ${RC_PID}
386	fi
387	exit 1
388}
389
390#
391# mount_critical_filesystems type
392#	Go through the list of critical filesystems as provided in
393#	the rc.conf(5) variable $critical_filesystems_${type}, checking
394#	each one to see if it is mounted, and if it is not, mounting it.
395#
396mount_critical_filesystems()
397{
398	eval _fslist=\$critical_filesystems_${1}
399	for _fs in $_fslist; do
400		mount | (
401			_ismounted=false
402			while read what _on on _type type; do
403				if [ $on = $_fs ]; then
404					_ismounted=true
405				fi
406			done
407			if $_ismounted; then
408				:
409			else
410				mount $_fs >/dev/null 2>&1
411			fi
412		)
413	done
414}
415
416#
417# check_pidfile pidfile procname [interpreter]
418#	Parses the first line of pidfile for a PID, and ensures
419#	that the process is running and matches procname.
420#	Prints the matching PID upon success, nothing otherwise.
421#	interpreter is optional; see _find_processes() for details.
422#
423check_pidfile()
424{
425	_pidfile=$1
426	_procname=$2
427	_interpreter=$3
428	if [ -z "$_pidfile" -o -z "$_procname" ]; then
429		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
430	fi
431	if [ ! -f $_pidfile ]; then
432		debug "pid file ($_pidfile): not readable."
433		return
434	fi
435	read _pid _junk < $_pidfile
436	if [ -z "$_pid" ]; then
437		debug "pid file ($_pidfile): no pid in file."
438		return
439	fi
440	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
441}
442
443#
444# check_process procname [interpreter]
445#	Ensures that a process (or processes) named procname is running.
446#	Prints a list of matching PIDs.
447#	interpreter is optional; see _find_processes() for details.
448#
449check_process()
450{
451	_procname=$1
452	_interpreter=$2
453	if [ -z "$_procname" ]; then
454		err 3 'USAGE: check_process procname [interpreter]'
455	fi
456	_find_processes $_procname ${_interpreter:-.} '-ax'
457}
458
459#
460# _find_processes procname interpreter psargs
461#	Search for procname in the output of ps generated by psargs.
462#	Prints the PIDs of any matching processes, space separated.
463#
464#	If interpreter == ".", check the following variations of procname
465#	against the first word of each command:
466#		procname
467#		`basename procname`
468#		`basename procname` + ":"
469#		"(" + `basename procname` + ")"
470#		"[" + `basename procname` + "]"
471#
472#	If interpreter != ".", read the first line of procname, remove the
473#	leading #!, normalise whitespace, append procname, and attempt to
474#	match that against each command, either as is, or with extra words
475#	at the end.  As an alternative, to deal with interpreted daemons
476#	using perl, the basename of the interpreter plus a colon is also
477#	tried as the prefix to procname.
478#
479_find_processes()
480{
481	if [ $# -ne 3 ]; then
482		err 3 'USAGE: _find_processes procname interpreter psargs'
483	fi
484	_procname=$1
485	_interpreter=$2
486	_psargs=$3
487
488	_pref=
489	if [ $_interpreter != "." ]; then	# an interpreted script
490		_script="${_chroot}${_chroot:+/}$_procname"
491		if [ -r "$_script" ]; then
492			read _interp < $_script	# read interpreter name
493			case "$_interp" in
494			\#!*)
495				_interp=${_interp#\#!}	# strip #!
496				set -- $_interp
497				case $1 in
498				*/bin/env)
499					shift	# drop env to get real name
500					;;
501				esac
502				if [ $_interpreter != $1 ]; then
503					warn "\$command_interpreter $_interpreter != $1"
504				fi
505				;;
506			*)
507				warn "no shebang line in $_script"
508				set -- $_interpreter
509				;;
510			esac
511		else
512			warn "cannot read shebang line from $_script"
513			set -- $_interpreter
514		fi
515		_interp="$* $_procname"		# cleanup spaces, add _procname
516		_interpbn=${1##*/}
517		_fp_args='_argv'
518		_fp_match='case "$_argv" in
519		    ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
520	else					# a normal daemon
521		_procnamebn=${_procname##*/}
522		_fp_args='_arg0 _argv'
523		_fp_match='case "$_arg0" in
524		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
525	fi
526
527	if checkyesno ${name}_svcj && [ "${_rc_svcj}" != jailing ]; then
528		JID=$(/usr/sbin/jls -j svcj-${name} jid 2>/dev/null)
529
530		case ${JID} in
531		''|*[!0-9]*)
532			# svcj-jail doesn't exist, fallback to host-check
533			JID=0
534			;;
535		esac
536	fi
537	_proccheck="\
538		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
539		while read _npid _jid '"$_fp_args"'; do
540			'"$_fp_match"'
541				if [ "$JID" -eq "$_jid" ];
542				then echo -n "$_pref$_npid";
543				_pref=" ";
544				fi
545				;;
546			esac
547		done'
548
549#	debug "in _find_processes: proccheck is ($_proccheck)."
550	eval $_proccheck
551}
552
553# sort_lite [-b] [-n] [-k POS] [-t SEP]
554#	A lite version of sort(1) (supporting a few options) that can be used
555#	before the real sort(1) is available (e.g., in scripts that run prior
556#	to mountcritremote). Requires only shell built-in functionality.
557#
558sort_lite()
559{
560	local funcname=sort_lite
561	local sort_sep="$IFS" sort_ignore_leading_space=
562	local sort_field=0 sort_strict_fields= sort_numeric=
563	local nitems=0 skip_leading=0 trim=
564
565	local OPTIND flag
566	while getopts bnk:t: flag; do
567		case "$flag" in
568		b) sort_ignore_leading_space=1 ;;
569		n) sort_numeric=1 sort_ignore_leading_space=1 ;;
570		k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
571			# NB: Unlike sort(1) only one POS allowed
572		t) sort_sep="$OPTARG"
573		   if [ ${#sort_sep} -gt 1 ]; then
574		   	echo "$funcname: multi-character tab \`$sort_sep'" >&2
575		   	return 1
576		   fi
577		   sort_strict_fields=1
578		   ;;
579		\?) return 1 ;;
580		esac
581	done
582	shift $(( $OPTIND - 1 ))
583
584	# Create transformation pattern to trim leading text if desired
585	case "$sort_field" in
586	""|[!0-9]*|*[!0-9.]*)
587		echo "$funcname: invalid sort field \`$sort_field'" >&2
588		return 1
589		;;
590	*.*)
591		skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
592		while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
593			trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
594		done
595	esac
596
597	# Copy input to series of local numbered variables
598	# NB: IFS of NULL preserves leading whitespace
599	local LINE
600	while IFS= read -r LINE || [ "$LINE" ]; do
601		nitems=$(( $nitems + 1 ))
602		local src_$nitems="$LINE"
603	done
604
605	#
606	# Sort numbered locals using insertion sort
607	#
608	local curitem curitem_orig curitem_mod curitem_haskey
609	local dest dest_orig dest_mod dest_haskey
610	local d gt n
611	local i=1
612	while [ $i -le $nitems ]; do
613		curitem_haskey=1 # Assume sort field (-k POS) exists
614		eval curitem=\"\$src_$i\"
615		curitem_mod="$curitem" # for modified comparison
616		curitem_orig="$curitem" # for original comparison
617
618		# Trim leading whitespace if desired
619		if [ "$sort_ignore_leading_space" ]; then
620			while case "$curitem_orig" in
621				[$IFS]*) : ;; *) false; esac
622			do
623				curitem_orig="${curitem_orig#?}"
624			done
625			curitem_mod="$curitem_orig"
626		fi
627
628		# Shift modified comparison value if sort field (-k POS) is > 1
629		n=$sort_field
630		while [ $n -gt 1 ]; do
631			case "$curitem_mod" in
632			*[$sort_sep]*)
633				# Cut text up-to (and incl.) first separator
634				curitem_mod="${curitem_mod#*[$sort_sep]}"
635
636				# Skip NULLs unless strict field splitting
637				[ "$sort_strict_fields" ] ||
638					[ "${curitem_mod%%[$sort_sep]*}" ] ||
639					[ $n -eq 2 ] ||
640					continue
641				;;
642			*)
643				# Asked for a field that doesn't exist
644				curitem_haskey= break
645			esac
646			n=$(( $n - 1 ))
647		done
648
649		# Trim trailing words if sort field >= 1
650		[ $sort_field -ge 1 -a "$sort_numeric" ] &&
651			curitem_mod="${curitem_mod%%[$sort_sep]*}"
652
653		# Apply optional trim (-k POS.TRIM) to cut leading characters
654		curitem_mod="${curitem_mod#$trim}"
655
656		# Determine the type of modified comparison to use initially
657		# NB: Prefer numerical if requested but fallback to standard
658		case "$curitem_mod" in
659		""|[!0-9]*) # NULL or begins with non-number
660			gt=">"
661			[ "$sort_numeric" ] && curitem_mod=0
662			;;
663		*)
664			if [ "$sort_numeric" ]; then
665				gt="-gt"
666				curitem_mod="${curitem_mod%%[!0-9]*}"
667					# NB: trailing non-digits removed
668					# otherwise numeric comparison fails
669			else
670				gt=">"
671			fi
672		esac
673
674		# If first time through, short-circuit below position-search
675		if [ $i -le 1 ]; then
676			d=0
677		else
678			d=1
679		fi
680
681		#
682		# Find appropriate element position
683		#
684		while [ $d -gt 0 ]
685		do
686			dest_haskey=$curitem_haskey
687			eval dest=\"\$dest_$d\"
688			dest_mod="$dest" # for modified comparison
689			dest_orig="$dest" # for original comparison
690
691			# Trim leading whitespace if desired
692			if [ "$sort_ignore_leading_space" ]; then
693				while case "$dest_orig" in
694					[$IFS]*) : ;; *) false; esac
695				do
696					dest_orig="${dest_orig#?}"
697				done
698				dest_mod="$dest_orig"
699			fi
700
701			# Shift modified value if sort field (-k POS) is > 1
702			n=$sort_field
703			while [ $n -gt 1 ]; do
704				case "$dest_mod" in
705				*[$sort_sep]*)
706					# Cut text up-to (and incl.) 1st sep
707					dest_mod="${dest_mod#*[$sort_sep]}"
708
709					# Skip NULLs unless strict fields
710					[ "$sort_strict_fields" ] ||
711					    [ "${dest_mod%%[$sort_sep]*}" ] ||
712					    [ $n -eq 2 ] ||
713					    continue
714					;;
715				*)
716					# Asked for a field that doesn't exist
717					dest_haskey= break
718				esac
719				n=$(( $n - 1 ))
720			done
721
722			# Trim trailing words if sort field >= 1
723			[ $sort_field -ge 1 -a "$sort_numeric" ] &&
724				dest_mod="${dest_mod%%[$sort_sep]*}"
725
726			# Apply optional trim (-k POS.TRIM), cut leading chars
727			dest_mod="${dest_mod#$trim}"
728
729			# Determine type of modified comparison to use
730			# NB: Prefer numerical if requested, fallback to std
731			case "$dest_mod" in
732			""|[!0-9]*) # NULL or begins with non-number
733				gt=">"
734				[ "$sort_numeric" ] && dest_mod=0
735				;;
736			*)
737				if [ "$sort_numeric" ]; then
738					gt="-gt"
739					dest_mod="${dest_mod%%[!0-9]*}"
740						# NB: kill trailing non-digits
741						# for numeric comparison safety
742				else
743					gt=">"
744				fi
745			esac
746
747			# Break if we've found the proper element position
748			if [ "$curitem_haskey" -a "$dest_haskey" ]; then
749				if [ "$dest_mod" = "$curitem_mod" ]; then
750					[ "$dest_orig" ">" "$curitem_orig" ] &&
751						break
752				elif [ "$dest_mod" $gt "$curitem_mod" ] \
753					2> /dev/null
754				then
755					break
756				fi
757			else
758				[ "$dest_orig" ">" "$curitem_orig" ] && break
759			fi
760
761			# Break if we've hit the end
762			[ $d -ge $i ] && break
763
764			d=$(( $d + 1 ))
765		done
766
767		# Shift remaining positions forward, making room for new item
768		n=$i
769		while [ $n -ge $d ]; do
770			# Shift destination item forward one placement
771			eval dest_$(( $n + 1 ))=\"\$dest_$n\"
772			n=$(( $n - 1 ))
773		done
774
775		# Place the element
776		if [ $i -eq 1 ]; then
777			local dest_1="$curitem"
778		else
779			local dest_$d="$curitem"
780		fi
781
782		i=$(( $i + 1 ))
783	done
784
785	# Print sorted results
786	d=1
787	while [ $d -le $nitems ]; do
788		eval echo \"\$dest_$d\"
789		d=$(( $d + 1 ))
790	done
791}
792
793#
794# wait_for_pids pid [pid ...]
795#	spins until none of the pids exist
796#
797wait_for_pids()
798{
799	local _list _prefix _nlist _j
800
801	_list="$@"
802	if [ -z "$_list" ]; then
803		return
804	fi
805	_prefix=
806	while true; do
807		_nlist="";
808		for _j in $_list; do
809			if kill -0 $_j 2>/dev/null; then
810				_nlist="${_nlist}${_nlist:+ }$_j"
811				[ -n "$_prefix" ] && sleep 1
812			fi
813		done
814		if [ -z "$_nlist" ]; then
815			break
816		fi
817		_list=$_nlist
818		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
819		_prefix=", "
820		pwait $_list 2>/dev/null
821	done
822	if [ -n "$_prefix" ]; then
823		echo "."
824	fi
825}
826
827#
828# get_pidfile_from_conf string file
829#
830#	Takes a string to search for in the specified file.
831#	Ignores lines with traditional comment characters.
832#
833# Example:
834#
835# if get_pidfile_from_conf string file; then
836#	pidfile="$_pidfile_from_conf"
837# else
838#	pidfile='appropriate default'
839# fi
840#
841get_pidfile_from_conf()
842{
843	if [ -z "$1" -o -z "$2" ]; then
844		err 3 "USAGE: get_pidfile_from_conf string file ($name)"
845	fi
846
847	local string file line
848
849	string="$1" ; file="$2"
850
851	if [ ! -s "$file" ]; then
852		err 3 "get_pidfile_from_conf: $file does not exist ($name)"
853	fi
854
855	while read line; do
856		case "$line" in
857		*[#\;]*${string}*)	continue ;;
858		*${string}*)		break ;;
859		esac
860	done < $file
861
862	if [ -n "$line" ]; then
863		line=${line#*/}
864		_pidfile_from_conf="/${line%%[\"\;]*}"
865	else
866		return 1
867	fi
868}
869
870#
871# check_startmsgs
872#	If rc_quiet is set (usually as a result of using faststart at
873#	boot time) check if rc_startmsgs is enabled.
874#
875check_startmsgs()
876{
877	if [ -n "$rc_quiet" ]; then
878		checkyesno rc_startmsgs
879	else
880		return 0
881	fi
882}
883
884#
885# startmsg
886#	Preferred method to use when displaying start messages in lieu of echo.
887#
888startmsg()
889{
890	check_startmsgs && echo "$@"
891}
892
893#
894# run_rc_command argument
895#	Search for argument in the list of supported commands, which is:
896#		"start stop restart rcvar status poll ${extra_commands}"
897#	If there's a match, run ${argument}_cmd or the default method
898#	(see below).
899#
900#	If argument has a given prefix, then change the operation as follows:
901#		Prefix	Operation
902#		------	---------
903#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
904#		force	Set ${rcvar} to YES, and set rc_force=yes
905#		one	Set ${rcvar} to YES
906#		quiet	Don't output some diagnostics, and set rc_quiet=yes
907#
908#	The following globals are used:
909#
910#	Name		Needed	Purpose
911#	----		------	-------
912#	name		y	Name of script.
913#
914#	command		n	Full path to command.
915#				Not needed if ${rc_arg}_cmd is set for
916#				each keyword.
917#
918#	command_args	n	Optional args/shell directives for command.
919#
920#	command_interpreter n	If not empty, command is interpreted, so
921#				call check_{pidfile,process}() appropriately.
922#
923#	desc		n	Description of script.
924#
925#	extra_commands	n	List of extra commands supported.
926#
927#	pidfile		n	If set, use check_pidfile $pidfile $command,
928#				otherwise use check_process $command.
929#				In either case, only check if $command is set.
930#
931#	procname	n	Process name to check for instead of $command.
932#
933#	rcvar		n	This is checked with checkyesno to determine
934#				if the action should be run.
935#
936#	${name}_program	n	Full path to command.
937#				Meant to be used in /etc/rc.conf to override
938#				${command}.
939#
940#	${name}_chroot	n	Directory to chroot to before running ${command}
941#				Requires /usr to be mounted.
942#
943#	${name}_chdir	n	Directory to cd to before running ${command}
944#				(if not using ${name}_chroot).
945#
946#	${name}_cpuset	n	A list of CPUs to run ${command} on.
947#				Requires /usr to be mounted.
948#
949#	${name}_flags	n	Arguments to call ${command} with.
950#				NOTE:	$flags from the parent environment
951#					can be used to override this.
952#
953#	${name}_env	n	Environment variables to run ${command} with.
954#
955#	${name}_env_file n	File to source variables to run ${command} with.
956#
957#	${name}_fib	n	Routing table number to run ${command} with.
958#
959#	${name}_nice	n	Nice level to run ${command} at.
960#
961#	${name}_oomprotect n	Don't kill ${command} when swap space is exhausted.
962#
963#	${name}_umask	n	The file creation mask to run ${command} with.
964#
965#	${name}_user	n	User to run ${command} as, using su(1) if not
966#				using ${name}_chroot.
967#				Requires /usr to be mounted.
968#
969#	${name}_group	n	Group to run chrooted ${command} as.
970#				Requires /usr to be mounted.
971#
972#	${name}_groups	n	Comma separated list of supplementary groups
973#				to run the chrooted ${command} with.
974#				Requires /usr to be mounted.
975#
976#	${name}_prepend	n	Command added before ${command}.
977#
978#	${name}_setup	n	Command executed before ${command}.
979#
980#	${name}_login_class n	Login class to use, else "daemon".
981#
982#	${name}_limits	n	limits(1) to apply to ${command}.
983#
984#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
985#				Otherwise, use default command (see below)
986#
987#	${rc_arg}_precmd n	If set, run just before performing the
988#				${rc_arg}_cmd method in the default
989#				operation (i.e, after checking for required
990#				bits and process (non)existence).
991#				If this completes with a non-zero exit code,
992#				don't run ${rc_arg}_cmd.
993#
994#	${rc_arg}_postcmd n	If set, run just after performing the
995#				${rc_arg}_cmd method, if that method
996#				returned a zero exit code.
997#
998#	required_dirs	n	If set, check for the existence of the given
999#				directories before running a (re)start command.
1000#
1001#	required_files	n	If set, check for the readability of the given
1002#				files before running a (re)start command.
1003#
1004#	required_modules n	If set, ensure the given kernel modules are
1005#				loaded before running a (re)start command.
1006#				The check and possible loads are actually
1007#				done after start_precmd so that the modules
1008#				aren't loaded in vain, should the precmd
1009#				return a non-zero status to indicate a error.
1010#				If a word in the list looks like "foo:bar",
1011#				"foo" is the KLD file name and "bar" is the
1012#				module name.  If a word looks like "foo~bar",
1013#				"foo" is the KLD file name and "bar" is a
1014#				egrep(1) pattern matching the module name.
1015#				Otherwise the module name is assumed to be
1016#				the same as the KLD file name, which is most
1017#				common.  See load_kld().
1018#
1019#	required_vars	n	If set, perform checkyesno on each of the
1020#				listed variables before running the default
1021#				(re)start command.
1022#
1023#	Default behaviour for a given argument, if no override method is
1024#	provided:
1025#
1026#	Argument	Default behaviour
1027#	--------	-----------------
1028#	start		if !running && checkyesno ${rcvar}
1029#				${command}
1030#
1031#	stop		if ${pidfile}
1032#				rc_pid=$(check_pidfile $pidfile $command)
1033#			else
1034#				rc_pid=$(check_process $command)
1035#			kill $sig_stop $rc_pid
1036#			wait_for_pids $rc_pid
1037#			($sig_stop defaults to TERM.)
1038#
1039#	reload		Similar to stop, except use $sig_reload instead,
1040#			and don't wait_for_pids.
1041#			$sig_reload defaults to HUP.
1042#			Note that `reload' isn't provided by default,
1043#			it should be enabled via $extra_commands.
1044#
1045#	restart		Run `stop' then `start'.
1046#
1047#	status		Show if ${command} is running, etc.
1048#
1049#	poll		Wait for ${command} to exit.
1050#
1051#	rcvar		Display what rc.conf variable is used (if any).
1052#
1053#	enabled		Return true if the service is enabled.
1054#
1055#	describe	Show the service's description
1056#
1057#	extracommands	Show the service's extra commands
1058#
1059#	Variables available to methods, and after run_rc_command() has
1060#	completed:
1061#
1062#	Variable	Purpose
1063#	--------	-------
1064#	rc_arg		Argument to command, after fast/force/one processing
1065#			performed
1066#
1067#	rc_flags	Flags to start the default command with.
1068#			Defaults to ${name}_flags, unless overridden
1069#			by $flags from the environment.
1070#			This variable may be changed by the precmd method.
1071#
1072#	rc_service	Path to the service being executed, in case the service
1073#			needs to re-invoke itself.
1074#
1075#	rc_pid		PID of command (if appropriate)
1076#
1077#	rc_fast		Not empty if "fast" was provided (q.v.)
1078#
1079#	rc_force	Not empty if "force" was provided (q.v.)
1080#
1081#	rc_quiet	Not empty if "quiet" was provided
1082#
1083#
1084run_rc_command()
1085{
1086	_return=0
1087	rc_arg=$1
1088	if [ -z "$name" ]; then
1089		err 3 'run_rc_command: $name is not set.'
1090	fi
1091
1092	DebugOn rc:all rc:all:$rc_arg rc:$name rc:$name:$rc_arg $name:$rc_arg
1093
1094	# Don't repeat the first argument when passing additional command-
1095	# line arguments to the command subroutines.
1096	#
1097	shift 1
1098	rc_extra_args="$*"
1099
1100	_rc_prefix=
1101	case "$rc_arg" in
1102	fast*)				# "fast" prefix; don't check pid
1103		rc_arg=${rc_arg#fast}
1104		rc_fast=yes
1105		rc_quiet=yes
1106		;;
1107	force*)				# "force" prefix; always run
1108		rc_force=yes
1109		_rc_prefix=force
1110		rc_arg=${rc_arg#${_rc_prefix}}
1111		if [ -n "${rcvar}" ]; then
1112			eval ${rcvar}=YES
1113		fi
1114		;;
1115	one*)				# "one" prefix; set ${rcvar}=yes
1116		_rc_prefix=one
1117		rc_arg=${rc_arg#${_rc_prefix}}
1118		if [ -n "${rcvar}" ]; then
1119			eval ${rcvar}=YES
1120		fi
1121		;;
1122	quiet*)				# "quiet" prefix; omit some messages
1123		_rc_prefix=quiet
1124		rc_arg=${rc_arg#${_rc_prefix}}
1125		rc_quiet=yes
1126		;;
1127	esac
1128
1129	eval _override_command=\$${name}_program
1130	command=${_override_command:-$command}
1131
1132	_keywords="start stop restart rcvar enable disable delete enabled describe extracommands $extra_commands"
1133	rc_pid=
1134	_pidcmd=
1135	_procname=${procname:-${command}}
1136
1137	eval _cpuset=\$${name}_cpuset
1138
1139	# Loose validation of the configured cpuset; just make sure it starts
1140	# with a number.  There have also been cases in the past where a hyphen
1141	# in a service name has caused eval errors, which trickle down into
1142	# various variables; don't let a situation like that break a bunch of
1143	# services just because of cpuset(1).
1144	case "$_cpuset" in
1145	[0-9]*)	;;
1146	*)	_cpuset="" ;;
1147	esac
1148
1149	_cpusetcmd=
1150	if [ -n "$_cpuset" ]; then
1151		_cpusetcmd="$CPUSET -l $_cpuset"
1152	fi
1153
1154	# If a specific jail has a specific svcj request, honor it (YES/NO).
1155	# If not (variable empty), evaluate the global svcj catch-all.
1156	# A global YES can be overriden by a specific NO, and a global NO is overriden
1157	# by a specific YES.
1158	eval _svcj=\$${name}_svcj
1159	if [ -z "$_svcj" ]; then
1160		_svcj=${svcj_all_enable}
1161		if [ -z "$_svcj" ]; then
1162			eval ${name}_svcj=NO
1163		fi
1164	fi
1165
1166					# setup pid check command
1167	if [ -n "$_procname" ]; then
1168		if [ -n "$pidfile" ]; then
1169			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
1170		else
1171			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
1172		fi
1173		_keywords="${_keywords} status poll"
1174	else
1175		if [ ! -z "${status_cmd}" ]
1176		then
1177			_keywords="${_keywords} status"
1178		fi
1179	fi
1180
1181	if [ -z "$rc_arg" ]; then
1182		rc_usage $_keywords
1183	fi
1184
1185	if [ "$rc_arg" = "enabled" ] ; then
1186		checkyesno ${rcvar}
1187		return $?
1188	fi
1189
1190	if [ -n "$flags" ]; then	# allow override from environment
1191		rc_flags=$flags
1192	else
1193		eval rc_flags=\$${name}_flags
1194	fi
1195	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
1196	    _nice=\$${name}_nice	_user=\$${name}_user \
1197	    _group=\$${name}_group	_groups=\$${name}_groups \
1198	    _fib=\$${name}_fib		_env=\$${name}_env \
1199	    _prepend=\$${name}_prepend	_login_class=\${${name}_login_class:-daemon} \
1200	    _limits=\$${name}_limits	_oomprotect=\$${name}_oomprotect \
1201	    _setup=\$${name}_setup	_env_file=\$${name}_env_file \
1202	    _umask=\$${name}_umask	_svcj_options=\$${name}_svcj_options
1203
1204	if [ -n "$_env_file" ] && [ -r "${_env_file}" ]; then	# load env from file
1205		set -a
1206		. $_env_file
1207		set +a
1208	fi
1209
1210	if [ -n "$_user" ]; then	# unset $_user if running as that user
1211		if [ "$_user" = "$(eval $IDCMD)" ]; then
1212			unset _user
1213		fi
1214	fi
1215
1216	if [ -n "$_svcj_options" ]; then	# translate service jail options
1217		_svcj_cmd_options=""
1218
1219		for _svcj_option in $_svcj_options; do
1220			case "$_svcj_option" in
1221				mlock)
1222					_svcj_cmd_options="allow.mlock ${_svcj_cmd_options}"
1223					;;
1224				netv4)
1225					_svcj_cmd_options="ip4=inherit allow.reserved_ports ${_svcj_cmd_options}"
1226					;;
1227				netv6)
1228					_svcj_cmd_options="ip6=inherit allow.reserved_ports ${_svcj_cmd_options}"
1229					;;
1230				net_basic)
1231					_svcj_cmd_options="ip4=inherit ip6=inherit allow.reserved_ports ${_svcj_cmd_options}"
1232					;;
1233				net_raw)
1234					_svcj_cmd_options="allow.raw_sockets ${_svcj_cmd_options}"
1235					;;
1236				net_all)
1237					_svcj_cmd_options="allow.socket_af allow.raw_sockets allow.reserved_ports ip4=inherit ip6=inherit ${_svcj_cmd_options}"
1238					;;
1239				nfsd)
1240					_svcj_cmd_options="allow.nfsd enforce_statfs=1 ${_svcj_cmd_options}"
1241					;;
1242				sysvipc)
1243					_svcj_cmd_options="sysvmsg=inherit sysvsem=inherit sysvshm=inherit  ${_svcj_cmd_options}"
1244					;;
1245				vmm)
1246					_svcj_cmd_options="allow.vmm ${_svcj_cmd_options}"
1247					;;
1248				*)
1249					echo ${name}: unknown service jail option: $_svcj_option
1250					;;
1251			esac
1252		done
1253	fi
1254
1255	[ -z "$autoboot" ] && eval $_pidcmd	# determine the pid if necessary
1256
1257	for _elem in $_keywords; do
1258		if [ "$_elem" != "$rc_arg" ]; then
1259			continue
1260		fi
1261					# if ${rcvar} is set, $1 is not "rcvar", "describe",
1262					# "enable", "delete" or "status", and ${rc_pid} is
1263					# not set, run:
1264					#	checkyesno ${rcvar}
1265					# and return if that failed
1266					#
1267		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" \
1268		    -a "$rc_arg" != "delete" -a "$rc_arg" != "enable" \
1269		    -a "$rc_arg" != "describe" -a "$rc_arg" != "status" ] ||
1270		    [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
1271			if ! checkyesno ${rcvar}; then
1272				if [ -n "${rc_quiet}" ]; then
1273					return 0
1274				fi
1275				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
1276				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
1277				echo "instead of '${rc_arg}'."
1278				return 0
1279			fi
1280		fi
1281
1282		if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
1283			if [ -z "$rc_quiet" ]; then
1284				echo 1>&2 "${name} already running? " \
1285				    "(pid=$rc_pid)."
1286			fi
1287			return 1
1288		fi
1289
1290					# if there's a custom ${XXX_cmd},
1291					# run that instead of the default
1292					#
1293		eval _cmd=\$${rc_arg}_cmd \
1294		     _precmd=\$${rc_arg}_precmd \
1295		     _postcmd=\$${rc_arg}_postcmd
1296
1297		if [ -n "$_cmd" ]; then
1298			rc_trace 1 "$_cmd"
1299			if [ -n "$_env" ]; then
1300				eval "export -- $_env"
1301			fi
1302
1303			if [ "${_rc_svcj}" != jailing ]; then
1304				_run_rc_precmd || return 1
1305			fi
1306			if ! checkyesno ${name}_svcj; then
1307				_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || return 1
1308			else
1309				case "$rc_arg" in
1310				start)
1311					if [ "${_rc_svcj}" != jailing ]; then
1312						_return=1
1313						$JAIL_CMD -c $_svcj_generic_params $_svcj_cmd_options \
1314						    exec.start="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}start $rc_extra_args" \
1315						    exec.stop="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}stop $rc_extra_args" \
1316						    exec.consolelog="/var/log/svcj_${name}_console.log" \
1317						    name=svcj-${name} && _return=0
1318					else
1319						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1320					fi
1321					;;
1322				stop)
1323					if [ "${_rc_svcj}" != jailing ]; then
1324						$SERVICE -E _rc_svcj=jailing -j svcj-${name} ${name} ${_rc_prefix}stop $rc_extra_args || _return=1
1325						$JAIL_CMD -r svcj-${name} 2>/dev/null
1326					else
1327						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1328					fi
1329					;;
1330				restart|status) ;; # no special case needed for svcj or handled somewhere else
1331				*)
1332					eval _rc_svcj_extra_cmd=\$${name}_${rc_arg}_svcj_enable
1333					: ${_rc_svcj_extra_cmd:=NO}
1334					if checkyesno _rc_svcj_extra_cmd && [ "${_rc_svcj}" != jailing ]; then
1335						$SERVICE -v -E _rc_svcj=jailing -j svcj-${name} ${name} ${_rc_prefix}${rc_arg} $rc_extra_args || _return=1
1336					else
1337						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1338					fi
1339					;;
1340				esac
1341			fi
1342			if [ "${_rc_svcj}" != jailing ]; then
1343				_run_rc_postcmd
1344			fi
1345			return $_return
1346		fi
1347
1348		case "$rc_arg" in	# default operations...
1349
1350		describe)
1351			if [ -n "$desc" ]; then
1352				echo "$desc"
1353			fi
1354			;;
1355
1356		extracommands)
1357			echo "$extra_commands"
1358			;;
1359
1360		enable)
1361			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=YES") &&
1362				echo "$name enabled in ${_out%%:*}"
1363			;;
1364
1365		disable)
1366			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=NO") &&
1367				echo "$name disabled in ${_out%%:*}"
1368			;;
1369
1370		delete)
1371			_files=
1372			for _file in $(sysrc -lEs "$name"); do
1373				_out=$(sysrc -Fif $_file "$rcvar") && _files="$_files $_file"
1374			done
1375			/usr/sbin/sysrc -x "$rcvar" && echo "$rcvar deleted in ${_files# }"
1376				# delete file in rc.conf.d if desired and empty.
1377			checkyesno service_delete_empty || _files=
1378			for _file in $_files; do
1379				[ "$_file" = "${_file#*/rc.conf.d/}" ] && continue
1380				[ $(/usr/bin/stat -f%z $_file) -gt 0 ] && continue
1381				/bin/rm "$_file" && echo "Empty file $_file removed"
1382			done
1383			;;
1384
1385		status)
1386			_run_rc_precmd || return 1
1387			if [ -n "$rc_pid" ]; then
1388				echo "${name} is running as pid $rc_pid."
1389			else
1390				echo "${name} is not running."
1391				return 1
1392			fi
1393			_run_rc_postcmd
1394			;;
1395
1396		start)
1397			if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1398				warn "run_rc_command: cannot run $command"
1399				return 1
1400			fi
1401
1402			if [ "${_rc_svcj}" != jailing ]; then
1403				if ! _run_rc_precmd; then
1404					warn "failed precmd routine for ${name}"
1405					return 1
1406				fi
1407			fi
1408
1409			if checkyesno ${name}_svcj; then
1410				if [ "${_rc_svcj}" != jailing ]; then
1411					$JAIL_CMD -c $_svcj_generic_params $_svcj_cmd_options\
1412					    exec.start="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}start $rc_extra_args" \
1413					    exec.stop="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}stop $rc_extra_args" \
1414					    exec.consolelog="/var/log/svcj_${name}_console.log" \
1415					    name=svcj-${name} || return 1
1416				fi
1417			fi
1418
1419					# setup the full command to run
1420					#
1421			startmsg "Starting ${name}."
1422			if [ -n "$_chroot" ]; then
1423				_cd=
1424				_doit="\
1425${_nice:+nice -n $_nice }\
1426$_cpusetcmd \
1427${_fib:+setfib -F $_fib }\
1428${_env:+env $_env }\
1429chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1430$_chroot $command $rc_flags $command_args"
1431			else
1432				_cd="${_chdir:+cd $_chdir && }"
1433				_doit="\
1434${_fib:+setfib -F $_fib }\
1435${_env:+env $_env }\
1436$_cpusetcmd $command $rc_flags $command_args"
1437				if [ -n "$_user" ]; then
1438				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1439				fi
1440				if [ -n "$_nice" ]; then
1441					if [ -z "$_user" ]; then
1442						_doit="sh -c \"$_doit\""
1443					fi
1444					_doit="nice -n $_nice $_doit"
1445				fi
1446				if [ -n "$_prepend" ]; then
1447					_doit="$_prepend $_doit"
1448				fi
1449			fi
1450
1451			if [ -n "$_setup" ]; then
1452				if ! _run_rc_doit "$_setup"; then
1453					warn "failed to setup ${name}"
1454				fi
1455			fi
1456
1457					# Prepend default limits
1458			_doit="$_cd limits -C $_login_class $_limits $_doit"
1459
1460
1461			local _really_run_it=true
1462			if checkyesno ${name}_svcj; then
1463				if [ "${_rc_svcj}" != jailing ]; then
1464					_really_run_it=false
1465				fi
1466			fi
1467
1468			if [ "$_really_run_it" = true ]; then
1469					# run the full command
1470					#
1471				if ! _run_rc_doit "$_doit"; then
1472					warn "failed to start ${name}"
1473					return 1
1474				fi
1475			fi
1476
1477			if [ "${_rc_svcj}" != jailing ]; then
1478					# finally, run postcmd
1479					#
1480				_run_rc_postcmd
1481			fi
1482			;;
1483
1484		stop)
1485			if [ -z "$rc_pid" ]; then
1486				[ -n "$rc_fast" ] && return 0
1487				_run_rc_notrunning
1488				return 1
1489			fi
1490
1491			_run_rc_precmd || return 1
1492
1493					# send the signal to stop
1494					#
1495			echo "Stopping ${name}."
1496			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1497			_run_rc_doit "$_doit" || return 1
1498
1499					# wait for the command to exit,
1500					# and run postcmd.
1501			wait_for_pids $rc_pid
1502
1503			if checkyesno ${name}_svcj; then
1504				# remove service jail
1505				$JAIL_CMD -r svcj-${name} 2>/dev/null
1506			fi
1507
1508			_run_rc_postcmd
1509			;;
1510
1511		reload)
1512			if [ -z "$rc_pid" ]; then
1513				_run_rc_notrunning
1514				return 1
1515			fi
1516
1517			_run_rc_precmd || return 1
1518
1519			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1520			_run_rc_doit "$_doit" || return 1
1521
1522			_run_rc_postcmd
1523			;;
1524
1525		restart)
1526					# prevent restart being called more
1527					# than once by any given script
1528					#
1529			if ${_rc_restart_done:-false}; then
1530				return 0
1531			fi
1532			_rc_restart_done=true
1533
1534			_run_rc_precmd || return 1
1535
1536			# run those in a subshell to keep global variables
1537			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1538			( run_rc_command ${_rc_prefix}start $rc_extra_args )
1539			_return=$?
1540			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1541
1542			_run_rc_postcmd
1543			;;
1544
1545		poll)
1546			_run_rc_precmd || return 1
1547			if [ -n "$rc_pid" ]; then
1548				wait_for_pids $rc_pid
1549			fi
1550			_run_rc_postcmd
1551			;;
1552
1553		rcvar)
1554			echo -n "# $name"
1555			if [ -n "$desc" ]; then
1556				echo " : $desc"
1557			else
1558				echo ""
1559			fi
1560			echo "#"
1561			# Get unique vars in $rcvar $rcvars
1562			for _v in $rcvar $rcvars; do
1563				case $v in
1564				$_v\ *|\ *$_v|*\ $_v\ *) ;;
1565				*)	v="${v# } $_v" ;;
1566				esac
1567			done
1568
1569			# Display variables.
1570			for _v in $v; do
1571				if [ -z "$_v" ]; then
1572					continue
1573				fi
1574
1575				eval _desc=\$${_v}_desc
1576				eval _defval=\$${_v}_defval
1577				_h="-"
1578
1579				eval echo \"$_v=\\\"\$$_v\\\"\"
1580				# decode multiple lines of _desc
1581				while [ -n "$_desc" ]; do
1582					case $_desc in
1583					*^^*)
1584						echo "# $_h ${_desc%%^^*}"
1585						_desc=${_desc#*^^}
1586						_h=" "
1587						;;
1588					*)
1589						echo "# $_h ${_desc}"
1590						break
1591						;;
1592					esac
1593				done
1594				echo "#   (default: \"$_defval\")"
1595			done
1596			echo ""
1597			;;
1598
1599		*)
1600			rc_usage $_keywords
1601			;;
1602
1603		esac
1604
1605		# Apply protect(1) to the PID if ${name}_oomprotect is set.
1606		case "$rc_arg" in
1607		start)
1608			# We cannot use protect(1) inside jails.
1609			if [ -n "$_oomprotect" ] && [ -f "${PROTECT}" ] &&
1610			    [ "$(sysctl -n security.jail.jailed)" -eq 0 ]; then
1611				[ -z "${rc_pid}" ] && eval $_pidcmd
1612				case $_oomprotect in
1613				[Aa][Ll][Ll])
1614					${PROTECT} -d -i -p ${rc_pid}
1615					;;
1616				[Yy][Ee][Ss])
1617					${PROTECT} -p ${rc_pid}
1618					;;
1619				esac
1620			fi
1621		;;
1622		esac
1623
1624		return $_return
1625	done
1626
1627	echo 1>&2 "$0: unknown directive '$rc_arg'."
1628	rc_usage $_keywords
1629	# not reached
1630}
1631
1632#
1633# Helper functions for run_rc_command: common code.
1634# They use such global variables besides the exported rc_* ones:
1635#
1636#	name	       R/W
1637#	------------------
1638#	_precmd		R
1639#	_postcmd	R
1640#	_return		W
1641#
1642_run_rc_precmd()
1643{
1644	check_required_before "$rc_arg" || return 1
1645
1646	if [ -n "$_precmd" ]; then
1647		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1648		eval "$_precmd $rc_extra_args"
1649		_return=$?
1650
1651		# If precmd failed and force isn't set, request exit.
1652		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1653			return 1
1654		fi
1655	fi
1656
1657	check_required_after "$rc_arg" || return 1
1658
1659	return 0
1660}
1661
1662_run_rc_postcmd()
1663{
1664	if [ -n "$_postcmd" ]; then
1665		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1666		eval "$_postcmd $rc_extra_args"
1667		_return=$?
1668	fi
1669	return 0
1670}
1671
1672_run_rc_doit()
1673{
1674	local _m
1675
1676	debug "run_rc_command: doit: $*"
1677	_m=$(umask)
1678	${_umask:+umask ${_umask}}
1679	eval "$@"
1680	_return=$?
1681	umask ${_m}
1682
1683	# If command failed and force isn't set, request exit.
1684	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1685		return 1
1686	fi
1687
1688	return 0
1689}
1690
1691_run_rc_notrunning()
1692{
1693	local _pidmsg
1694
1695	if [ -n "$pidfile" ]; then
1696		_pidmsg=" (check $pidfile)."
1697	else
1698		_pidmsg=
1699	fi
1700	echo 1>&2 "${name} not running?${_pidmsg}"
1701}
1702
1703_run_rc_killcmd()
1704{
1705	local _cmd
1706
1707	_cmd="kill -$1 $rc_pid"
1708	if [ -n "$_user" ]; then
1709		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1710	fi
1711	echo "$_cmd"
1712}
1713
1714#
1715# run_rc_script file arg
1716#	Start the script `file' with `arg', and correctly handle the
1717#	return value from the script.
1718#	If `file' ends with `.sh' and lives in /etc/rc.d, ignore it as it's
1719#	an old-style startup file.
1720#	If `file' ends with `.sh' and does not live in /etc/rc.d, it's sourced
1721#	into the current environment if $rc_fast_and_loose is set; otherwise
1722#	it is run as a child process.
1723#	If `file' appears to be a backup or scratch file, ignore it.
1724#	Otherwise if it is executable run as a child process.
1725#
1726run_rc_script()
1727{
1728	_file=$1
1729	_arg=$2
1730	if [ -z "$_file" -o -z "$_arg" ]; then
1731		err 3 'USAGE: run_rc_script file arg'
1732	fi
1733
1734	unset	name command command_args command_interpreter \
1735		extra_commands pidfile procname \
1736		rcvar rcvars rcvars_obsolete required_dirs required_files \
1737		required_vars
1738	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1739
1740	rc_trace 0 "$_file $_arg"
1741	# don't use it if we don't trust it
1742	is_verified $_file || return
1743
1744	rc_service="$_file"
1745	case "$_file" in
1746	/etc/rc.d/*.sh)			# no longer allowed in the base
1747		warn "Ignoring old-style startup script $_file"
1748		;;
1749	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
1750		warn "Ignoring scratch file $_file"
1751		;;
1752	*)				# run in subshell
1753		if [ -x $_file ]; then
1754			DebugOn $_file $_file:$_arg rc:${_file##*/} rc:${_file##*/}:$_arg ${_file##*/} ${_file##*/}:$_arg
1755
1756			if [ -n "$rc_boottrace" ]; then
1757				boottrace_fn "$_file" "$_arg"
1758			elif [ -n "$rc_fast_and_loose" ]; then
1759				set $_arg; . $_file
1760			else
1761				( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1762				  trap "echo Script $_file interrupted >&2 ; exit 1" 2
1763				  trap "echo Script $_file running >&2" 29
1764				  set $_arg; . $_file )
1765			fi
1766			DebugOff $_file $_file:$_arg rc:${_file##*/} rc:${_file##*/}:$_arg ${_file##*/} ${_file##*/}:$_arg
1767		fi
1768		;;
1769	esac
1770}
1771
1772#
1773# run_rc_scripts [options] file [...]
1774#
1775# Call `run_rc_script' for each "file" unless already listed in
1776# $_rc_elem_done.
1777#
1778# Options:
1779#
1780#	--arg "arg"
1781#		Pass "arg" to `run_rc_script' default is $_boot.
1782#
1783#	--break "marker"
1784#		If any "file" matches "marker" stop processing.
1785#
1786_rc_elem_done=
1787run_rc_scripts()
1788{
1789	local _arg=${_boot}
1790	local _rc_elem
1791	local _rc_breaks=
1792
1793	while :; do
1794		case "$1" in
1795		--arg)
1796                        _arg="$2"
1797                        shift 2
1798                        ;;
1799		--break)
1800                        _rc_breaks="$_rc_breaks $2"
1801                        shift 2
1802                        ;;
1803		*)
1804                        break
1805                        ;;
1806		esac
1807	done
1808	for _rc_elem in "$@"; do
1809		: _rc_elem=$_rc_elem
1810		case " $_rc_elem_done " in
1811		*" $_rc_elem "*)
1812                        continue
1813                        ;;
1814		esac
1815		run_rc_script ${_rc_elem} ${_arg}
1816		_rc_elem_done="$_rc_elem_done $_rc_elem"
1817		case " $_rc_breaks " in
1818		*" ${_rc_elem##*/} "*)
1819                        break
1820                        ;;
1821		esac
1822	done
1823}
1824
1825boottrace_fn()
1826{
1827	local _file _arg
1828	_file=$1
1829	_arg=$2
1830
1831	if [ -n "$rc_fast_and_loose" ]; then
1832		boottrace_sysctl "$_file start"
1833		set $_arg; . $_file
1834		boottrace_sysctl "$_file done"
1835	else
1836		$boottrace_cmd "$_file" "$_arg"
1837	fi
1838}
1839
1840boottrace_sysctl()
1841{
1842	${SYSCTL} kern.boottrace.boottrace="$1"
1843}
1844
1845#
1846# load_rc_config [service]
1847#	Source in the configuration file(s) for a given service.
1848#	If no service is specified, only the global configuration
1849#	file(s) will be loaded.
1850#
1851load_rc_config()
1852{
1853	local _name _rcvar_val _var _defval _v _msg _new _d _dot
1854	_name=$1
1855	_dot=${load_rc_config_reader:-dot}
1856
1857	case "$_dot" in
1858	dot|[sv]dot)
1859		;;
1860	*)	warn "Ignoring invalid load_rc_config_reader"
1861		_dot=dot
1862		;;
1863	esac
1864	case "$1" in
1865	-s|--safe)
1866                _dot=sdot
1867                _name=$2
1868                shift
1869                ;;
1870	-v|--verify)
1871                _dot=vdot
1872                _name=$2
1873                shift
1874                ;;
1875	esac
1876
1877	DebugOn rc:$_name $_name
1878
1879	if ${_rc_conf_loaded:-false}; then
1880		:
1881	else
1882		if [ -r /etc/defaults/rc.conf ]; then
1883			debug "Sourcing /etc/defaults/rc.conf"
1884			$_dot /etc/defaults/rc.conf
1885			source_rc_confs
1886		elif [ -r /etc/rc.conf ]; then
1887			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1888			$_dot /etc/rc.conf
1889		fi
1890		_rc_conf_loaded=true
1891	fi
1892
1893	# If a service name was specified, attempt to load
1894	# service-specific configuration
1895	if [ -n "$_name" ] ; then
1896		for _d in /etc ${local_startup}; do
1897			_d=${_d%/rc.d}
1898			if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1899				debug "Sourcing ${_d}/rc.conf.d/$_name"
1900				$_dot ${_d}/rc.conf.d/"$_name"
1901			elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1902				local _rc
1903				for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1904					if [ -f "$_rc" ] ; then
1905						debug "Sourcing $_rc"
1906						$_dot "$_rc"
1907					fi
1908				done
1909			fi
1910		done
1911	fi
1912
1913	# Set defaults if defined.
1914	for _var in $rcvar $rcvars; do
1915		eval _defval=\$${_var}_defval
1916		if [ -n "$_defval" ]; then
1917			eval : \${$_var:=\$${_var}_defval}
1918		fi
1919	done
1920
1921	# check obsolete rc.conf variables
1922	for _var in $rcvars_obsolete; do
1923		eval _v=\$$_var
1924		eval _msg=\$${_var}_obsolete_msg
1925		eval _new=\$${_var}_newvar
1926		case $_v in
1927		"")
1928			;;
1929		*)
1930			if [ -z "$_new" ]; then
1931				_msg="Ignored."
1932			else
1933				eval $_new=\"\$$_var\"
1934				if [ -z "$_msg" ]; then
1935					_msg="Use \$$_new instead."
1936				fi
1937			fi
1938			warn "\$$_var is obsolete.  $_msg"
1939			;;
1940		esac
1941	done
1942}
1943
1944#
1945# load_rc_config_var name var
1946#	Read the rc.conf(5) var for name and set in the
1947#	current shell, using load_rc_config in a subshell to prevent
1948#	unwanted side effects from other variable assignments.
1949#
1950load_rc_config_var()
1951{
1952	if [ $# -ne 2 ]; then
1953		err 3 'USAGE: load_rc_config_var name var'
1954	fi
1955	eval $(eval '(
1956		load_rc_config '$1' >/dev/null;
1957		if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1958			echo '$2'=\'\''${'$2'}\'\'';
1959		fi
1960	)' )
1961}
1962
1963#
1964# rc_usage commands
1965#	Print a usage string for $0, with `commands' being a list of
1966#	valid commands.
1967#
1968rc_usage()
1969{
1970	echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1971
1972	_sep=
1973	for _elem; do
1974		echo -n 1>&2 "$_sep$_elem"
1975		_sep="|"
1976	done
1977	echo 1>&2 ")"
1978	exit 1
1979}
1980
1981#
1982# err exitval message
1983#	Display message to stderr and log to the syslog, and exit with exitval.
1984#
1985err()
1986{
1987	exitval=$1
1988	shift
1989
1990	if [ -x /usr/bin/logger ]; then
1991		logger "$0: ERROR: $*"
1992	fi
1993	echo 1>&2 "$0: ERROR: $*"
1994	exit $exitval
1995}
1996
1997#
1998# warn message
1999#	Display message to stderr and log to the syslog.
2000#
2001warn()
2002{
2003	if [ -x /usr/bin/logger ]; then
2004		logger "$0: WARNING: $*"
2005	fi
2006	echo 1>&2 "$0: WARNING: $*"
2007}
2008
2009#
2010# info message
2011#	Display informational message to stdout and log to syslog.
2012#
2013info()
2014{
2015	case ${rc_info} in
2016	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
2017		if [ -x /usr/bin/logger ]; then
2018			logger "$0: INFO: $*"
2019		fi
2020		echo "$0: INFO: $*"
2021		;;
2022	esac
2023}
2024
2025#
2026# debug message
2027#	If debugging is enabled in rc.conf output message to stderr.
2028#	BEWARE that you don't call any subroutine that itself calls this
2029#	function.
2030#
2031debug()
2032{
2033	case ${rc_debug} in
2034	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
2035		if [ -x /usr/bin/logger ]; then
2036			logger "$0: DEBUG: $*"
2037		fi
2038		echo 1>&2 "$0: DEBUG: $*"
2039		;;
2040	esac
2041}
2042
2043#
2044# backup_file action file cur backup
2045#	Make a backup copy of `file' into `cur', and save the previous
2046#	version of `cur' as `backup'.
2047#
2048#	The `action' keyword can be one of the following:
2049#
2050#	add		`file' is now being backed up (and is possibly
2051#			being reentered into the backups system).  `cur'
2052#			is created.
2053#
2054#	update		`file' has changed and needs to be backed up.
2055#			If `cur' exists, it is copied to `back'
2056#			and then `file' is copied to `cur'.
2057#
2058#	remove		`file' is no longer being tracked by the backups
2059#			system.  `cur' is moved `back'.
2060#
2061#
2062backup_file()
2063{
2064	_action=$1
2065	_file=$2
2066	_cur=$3
2067	_back=$4
2068
2069	case $_action in
2070	add|update)
2071		if [ -f $_cur ]; then
2072			cp -p $_cur $_back
2073		fi
2074		cp -p $_file $_cur
2075		chown root:wheel $_cur
2076		;;
2077	remove)
2078		mv -f $_cur $_back
2079		;;
2080	esac
2081}
2082
2083# make_symlink src link
2084#	Make a symbolic link 'link' to src from basedir. If the
2085#	directory in which link is to be created does not exist
2086#	a warning will be displayed and an error will be returned.
2087#	Returns 0 on success, 1 otherwise.
2088#
2089make_symlink()
2090{
2091	local src link linkdir _me
2092	src="$1"
2093	link="$2"
2094	linkdir="`dirname $link`"
2095	_me="make_symlink()"
2096
2097	if [ -z "$src" -o -z "$link" ]; then
2098		warn "$_me: requires two arguments."
2099		return 1
2100	fi
2101	if [ ! -d "$linkdir" ]; then
2102		warn "$_me: the directory $linkdir does not exist."
2103		return 1
2104	fi
2105	if ! ln -sf $src $link; then
2106		warn "$_me: unable to make a symbolic link from $link to $src"
2107		return 1
2108	fi
2109	return 0
2110}
2111
2112# devfs_rulesets_from_file file
2113#	Reads a set of devfs commands from file, and creates
2114#	the specified rulesets with their rules. Returns non-zero
2115#	if there was an error.
2116#
2117devfs_rulesets_from_file()
2118{
2119	local file _err _me _opts
2120	file="$1"
2121	_me="devfs_rulesets_from_file"
2122	_err=0
2123
2124	if [ -z "$file" ]; then
2125		warn "$_me: you must specify a file"
2126		return 1
2127	fi
2128	if [ ! -e "$file" ]; then
2129		debug "$_me: no such file ($file)"
2130		return 0
2131	fi
2132
2133	# Disable globbing so that the rule patterns are not expanded
2134	# by accident with matching filesystem entries.
2135	_opts=$-; set -f
2136
2137	debug "reading rulesets from file ($file)"
2138	{ while read line
2139	do
2140		case $line in
2141		\#*)
2142			continue
2143			;;
2144		\[*\]*)
2145			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
2146			if [ -z "$rulenum" ]; then
2147				warn "$_me: cannot extract rule number ($line)"
2148				_err=1
2149				break
2150			fi
2151			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
2152			if [ -z "$rulename" ]; then
2153				warn "$_me: cannot extract rule name ($line)"
2154				_err=1
2155				break;
2156			fi
2157			eval $rulename=\$rulenum
2158			debug "found ruleset: $rulename=$rulenum"
2159			if ! /sbin/devfs rule -s $rulenum delset; then
2160				_err=1
2161				break
2162			fi
2163			;;
2164		*)
2165			rulecmd="${line%%"\#*"}"
2166			# evaluate the command incase it includes
2167			# other rules
2168			if [ -n "$rulecmd" ]; then
2169				debug "adding rule ($rulecmd)"
2170				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
2171				then
2172					_err=1
2173					break
2174				fi
2175			fi
2176			;;
2177		esac
2178		if [ $_err -ne 0 ]; then
2179			debug "error in $_me"
2180			break
2181		fi
2182	done } < $file
2183	case $_opts in *f*) ;; *) set +f ;; esac
2184	return $_err
2185}
2186
2187# devfs_init_rulesets
2188#	Initializes rulesets from configuration files. Returns
2189#	non-zero if there was an error.
2190#
2191devfs_init_rulesets()
2192{
2193	local file _me
2194	_me="devfs_init_rulesets"
2195
2196	# Go through this only once
2197	if [ -n "$devfs_rulesets_init" ]; then
2198		debug "$_me: devfs rulesets already initialized"
2199		return
2200	fi
2201	for file in $devfs_rulesets; do
2202		if ! devfs_rulesets_from_file $file; then
2203			warn "$_me: could not read rules from $file"
2204			return 1
2205		fi
2206	done
2207	devfs_rulesets_init=1
2208	debug "$_me: devfs rulesets initialized"
2209	return 0
2210}
2211
2212# devfs_set_ruleset ruleset [dir]
2213#	Sets the default ruleset of dir to ruleset. The ruleset argument
2214#	must be a ruleset name as specified in devfs.rules(5) file.
2215#	Returns non-zero if it could not set it successfully.
2216#
2217devfs_set_ruleset()
2218{
2219	local devdir rs _me
2220	[ -n "$1" ] && eval rs=\$$1 || rs=
2221	[ -n "$2" ] && devdir="-m "$2"" || devdir=
2222	_me="devfs_set_ruleset"
2223
2224	if [ -z "$rs" ]; then
2225		warn "$_me: you must specify a ruleset number"
2226		return 1
2227	fi
2228	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
2229	if ! /sbin/devfs $devdir ruleset $rs; then
2230		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
2231		return 1
2232	fi
2233	return 0
2234}
2235
2236# devfs_apply_ruleset ruleset [dir]
2237#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
2238#	The ruleset argument must be a ruleset name as specified
2239#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
2240#	if it could not apply the ruleset.
2241#
2242devfs_apply_ruleset()
2243{
2244	local devdir rs _me
2245	[ -n "$1" ] && eval rs=\$$1 || rs=
2246	[ -n "$2" ] && devdir="-m "$2"" || devdir=
2247	_me="devfs_apply_ruleset"
2248
2249	if [ -z "$rs" ]; then
2250		warn "$_me: you must specify a ruleset"
2251		return 1
2252	fi
2253	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
2254	if ! /sbin/devfs $devdir rule -s $rs applyset; then
2255		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
2256		return 1
2257	fi
2258	return 0
2259}
2260
2261# devfs_domount dir [ruleset]
2262#	Mount devfs on dir. If ruleset is specified it is set
2263#	on the mount-point. It must also be a ruleset name as specified
2264#	in a devfs.rules(5) file. Returns 0 on success.
2265#
2266devfs_domount()
2267{
2268	local devdir rs _me
2269	devdir="$1"
2270	[ -n "$2" ] && rs=$2 || rs=
2271	_me="devfs_domount()"
2272
2273	if [ -z "$devdir" ]; then
2274		warn "$_me: you must specify a mount-point"
2275		return 1
2276	fi
2277	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
2278	if ! mount -t devfs dev "$devdir"; then
2279		warn "$_me: Unable to mount devfs on $devdir"
2280		return 1
2281	fi
2282	if [ -n "$rs" ]; then
2283		devfs_init_rulesets
2284		devfs_set_ruleset $rs $devdir
2285		devfs -m $devdir rule applyset
2286	fi
2287	return 0
2288}
2289
2290# Provide a function for normalizing the mounting of memory
2291# filesystems.  This should allow the rest of the code here to remain
2292# as close as possible between 5-current and 4-stable.
2293#   $1 = size
2294#   $2 = mount point
2295#   $3 = (optional) extra mdmfs flags
2296mount_md()
2297{
2298	if [ -n "$3" ]; then
2299		flags="$3"
2300	fi
2301	/sbin/mdmfs $flags -s $1 ${mfs_type} $2
2302}
2303
2304# Code common to scripts that need to load a kernel module
2305# if it isn't in the kernel yet. Syntax:
2306#   load_kld [-e regex] [-m module] file
2307# where -e or -m chooses the way to check if the module
2308# is already loaded:
2309#   regex is egrep'd in the output from `kldstat -v',
2310#   module is passed to `kldstat -m'.
2311# The default way is as though `-m file' were specified.
2312load_kld()
2313{
2314	local _loaded _mod _opt _re
2315
2316	while getopts "e:m:" _opt; do
2317		case "$_opt" in
2318		e) _re="$OPTARG" ;;
2319		m) _mod="$OPTARG" ;;
2320		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
2321		esac
2322	done
2323	shift $(($OPTIND - 1))
2324	if [ $# -ne 1 ]; then
2325		err 3 'USAGE: load_kld [-e regex] [-m module] file'
2326	fi
2327	_mod=${_mod:-$1}
2328	_loaded=false
2329	if [ -n "$_re" ]; then
2330		if kldstat -v | egrep -q -e "$_re"; then
2331			_loaded=true
2332		fi
2333	else
2334		if kldstat -q -m "$_mod"; then
2335			_loaded=true
2336		fi
2337	fi
2338	if ! $_loaded; then
2339		if ! kldload "$1"; then
2340			warn "Unable to load kernel module $1"
2341			return 1
2342		else
2343			info "$1 kernel module loaded."
2344			if [ -f "/etc/sysctl.kld.d/$1.conf" ]; then
2345				sysctl -f "/etc/sysctl.kld.d/$1.conf"
2346			fi
2347		fi
2348	else
2349		debug "load_kld: $1 kernel module already loaded."
2350	fi
2351	return 0
2352}
2353
2354# ltr str src dst [var]
2355#	Change every $src in $str to $dst.
2356#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
2357#	awk(1). If var is non-NULL, set it to the result.
2358ltr()
2359{
2360	local _str _src _dst _out _com _var
2361	_str="$1"
2362	_src="$2"
2363	_dst="$3"
2364	_var="$4"
2365	_out=""
2366
2367	local IFS="${_src}"
2368	for _com in ${_str}; do
2369		if [ -z "${_out}" ]; then
2370			_out="${_com}"
2371		else
2372			_out="${_out}${_dst}${_com}"
2373		fi
2374	done
2375	if [ -n "${_var}" ]; then
2376		setvar "${_var}" "${_out}"
2377	else
2378		echo "${_out}"
2379	fi
2380}
2381
2382# Creates a list of providers for GELI encryption.
2383geli_make_list()
2384{
2385	local devices devices2
2386	local provider mountpoint type options rest
2387
2388	# Create list of GELI providers from fstab.
2389	while read provider mountpoint type options rest ; do
2390		case ":${options}" in
2391		:*noauto*)
2392			noauto=yes
2393			;;
2394		*)
2395			noauto=no
2396			;;
2397		esac
2398
2399		case ":${provider}" in
2400		:#*)
2401			continue
2402			;;
2403		*.eli)
2404			# Skip swap devices.
2405			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
2406				continue
2407			fi
2408			devices="${devices} ${provider}"
2409			;;
2410		esac
2411	done < /etc/fstab
2412
2413	# Append providers from geli_devices.
2414	devices="${devices} ${geli_devices}"
2415
2416	for provider in ${devices}; do
2417		provider=${provider%.eli}
2418		provider=${provider#/dev/}
2419		devices2="${devices2} ${provider}"
2420	done
2421
2422	echo ${devices2}
2423}
2424
2425# Originally, root mount hold had to be released before mounting
2426# the root filesystem.  This delayed the boot, so it was changed
2427# to only wait if the root device isn't readily available.  This
2428# can result in rc scripts executing before all the devices - such
2429# as graid(8), or USB disks - can be accessed.  This function can
2430# be used to explicitly wait for root mount holds to be released.
2431root_hold_wait()
2432{
2433	local wait waited holders
2434
2435	waited=0
2436	while true; do
2437		holders="$(sysctl -n vfs.root_mount_hold)"
2438		if [ -z "${holders}" ]; then
2439			break;
2440		fi
2441		if [ ${waited} -eq 0 ]; then
2442			echo -n "Waiting ${root_hold_delay}s" \
2443			"for the root mount holders: ${holders}"
2444		else
2445			echo -n .
2446		fi
2447		if [ ${waited} -ge ${root_hold_delay} ]; then
2448			echo
2449			break
2450		fi
2451		sleep 1
2452		waited=$(($waited + 1))
2453	done
2454}
2455
2456# Find scripts in local_startup directories that use the old syntax
2457#
2458find_local_scripts_old() {
2459	zlist=''
2460	slist=''
2461	for dir in ${local_startup}; do
2462		if [ -d "${dir}" ]; then
2463			for file in ${dir}/[0-9]*.sh; do
2464				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2465				    continue
2466				zlist="$zlist $file"
2467			done
2468			for file in ${dir}/[!0-9]*.sh; do
2469				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2470				    continue
2471				slist="$slist $file"
2472			done
2473		fi
2474	done
2475}
2476
2477find_local_scripts_new() {
2478	local_rc=''
2479	for dir in ${local_startup}; do
2480		if [ -d "${dir}" ]; then
2481			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
2482				case "$file" in
2483				*.sample|*.pkgsave) ;;
2484				*)	if [ -x "$file" ]; then
2485						local_rc="${local_rc} ${file}"
2486					fi
2487					;;
2488				esac
2489			done
2490		fi
2491	done
2492}
2493
2494find_system_scripts() {
2495	system_rc=''
2496	for file in /etc/rc.d/*; do
2497		case "${file##*/}" in
2498		*.pkgsave) ;;
2499		*)	if [ -x "$file" ]; then
2500				system_rc="${system_rc} ${file}"
2501			fi
2502			;;
2503		esac
2504	done
2505}
2506
2507# check_required_{before|after} command
2508#	Check for things required by the command before and after its precmd,
2509#	respectively.  The two separate functions are needed because some
2510#	conditions should prevent precmd from being run while other things
2511#	depend on precmd having already been run.
2512#
2513check_required_before()
2514{
2515	local _f
2516
2517	case "$1" in
2518	start)
2519		for _f in $required_vars; do
2520			if ! checkyesno $_f; then
2521				warn "\$${_f} is not enabled."
2522				if [ -z "$rc_force" ]; then
2523					return 1
2524				fi
2525			fi
2526		done
2527
2528		for _f in $required_dirs; do
2529			if [ ! -d "${_f}/." ]; then
2530				warn "${_f} is not a directory."
2531				if [ -z "$rc_force" ]; then
2532					return 1
2533				fi
2534			fi
2535		done
2536
2537		for _f in $required_files; do
2538			if [ ! -r "${_f}" ]; then
2539				warn "${_f} is not readable."
2540				if [ -z "$rc_force" ]; then
2541					return 1
2542				fi
2543			fi
2544		done
2545		;;
2546	esac
2547
2548	return 0
2549}
2550
2551check_required_after()
2552{
2553	local _f _args
2554
2555	case "$1" in
2556	start)
2557		for _f in $required_modules; do
2558			case "${_f}" in
2559				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
2560				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
2561				*)	_args="${_f}" ;;
2562			esac
2563			if ! load_kld ${_args}; then
2564				if [ -z "$rc_force" ]; then
2565					return 1
2566				fi
2567			fi
2568		done
2569		;;
2570	esac
2571
2572	return 0
2573}
2574
2575# check_jail mib
2576#	Return true if security.jail.$mib exists and set to 1.
2577
2578check_jail()
2579{
2580	local _mib _v
2581
2582	_mib=$1
2583	if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2584		case $_v in
2585		1)	return 0;;
2586		esac
2587	fi
2588	return 1
2589}
2590
2591# check_kern_features mib
2592#	Return existence of kern.features.* sysctl MIB as true or
2593#	false.  The result will be cached in $_rc_cache_kern_features_
2594#	namespace.  "0" means the kern.features.X exists.
2595
2596check_kern_features()
2597{
2598	local _v
2599
2600	[ -n "$1" ] || return 1;
2601	eval _v=\$_rc_cache_kern_features_$1
2602	[ -n "$_v" ] && return "$_v";
2603
2604	if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2605		eval _rc_cache_kern_features_$1=0
2606		return 0
2607	else
2608		eval _rc_cache_kern_features_$1=1
2609		return 1
2610	fi
2611}
2612
2613# check_namevarlist var
2614#	Return "0" if ${name}_var is reserved in rc.subr.
2615
2616_rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend setup"
2617check_namevarlist()
2618{
2619	local _v
2620
2621	for _v in $_rc_namevarlist; do
2622	case $1 in
2623	$_v)	return 0 ;;
2624	esac
2625	done
2626
2627	return 1
2628}
2629
2630# _echoonce var msg mode
2631#	mode=0: Echo $msg if ${$var} is empty.
2632#	        After doing echo, a string is set to ${$var}.
2633#
2634#	mode=1: Echo $msg if ${$var} is a string with non-zero length.
2635#
2636_echoonce()
2637{
2638	local _var _msg _mode
2639	eval _var=\$$1
2640	_msg=$2
2641	_mode=$3
2642
2643	case $_mode in
2644	1)	[ -n "$_var" ] && echo "$_msg" ;;
2645	*)	[ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2646	esac
2647}
2648
2649# If the loader env variable rc.debug is set, turn on debugging. rc.conf will
2650# still override this, but /etc/defaults/rc.conf can't unconditionally set this
2651# since it would undo what we've done here.
2652if kenv -q rc.debug > /dev/null ; then
2653	rc_debug=YES
2654fi
2655
2656boottrace_cmd=`command -v boottrace`
2657if [ -n "$boottrace_cmd" ] && [ "`${SYSCTL_N} -q kern.boottrace.enabled`" = "1" ]; then
2658	rc_boottrace=YES
2659fi
2660
2661SED=${SED:-$(Exists -x /usr/bin/sed /rescue/sed)}
2662
2663# Allow for local additions and overrides.
2664# Use vdot to ensure the file has not been tampered with.
2665vdot /etc/local.rc.subr
2666
2667# Avoid noise - when we do not have /usr mounted,
2668# and we cannot use safe_dot without sed.
2669if ! have basename; then
2670	basename()
2671	{
2672		local b=${1%$2}
2673		echo ${b##*/}
2674	}
2675	tty()
2676	{
2677		return 0
2678	}
2679	# we cannot use safe_dot without sed
2680	[ -z "$SED" ] && _SAFE_EVAL_SH=:
2681fi
2682# safe_eval.sh provides safe_dot - for untrusted files
2683$_SAFE_EVAL_SH vdot /libexec/safe_eval.sh
2684$_DEBUG_SH vdot /libexec/debug.sh
2685
2686# Ensure we can still operate if debug.sh and
2687# safe_eval.sh are not found.
2688if have DebugOn; then
2689	# allow DEBUG_SH to be set from loader prompt
2690	DEBUG_SH=${DEBUG_SH:-$(kenv -q DEBUG_SH)}
2691else
2692	DebugOn() { return 0; }
2693	DebugOff() { return 0; }
2694fi
2695if ! have save_dot; then
2696	safe_dot() { dot "$@"; }
2697fi
2698